VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsDrawText"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Type DRAWTEXTPARAMS
    cbSize As Long
    iTabLength As Long
    iLeftMargin As Long
    iRightMargin As Long
    uiLengthDrawn As Long
End Type

Private Const LF_FACESIZE = 32

Private Type LOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(LF_FACESIZE) As Byte
End Type

Private Declare Function DrawTextEx Lib "user32" Alias "DrawTextExA" (ByVal hdc As Long, ByVal lpsz As String, ByVal n As Long, lpRect As RECT, ByVal un As Long, lpDrawTextParams As DRAWTEXTPARAMS) As Long
Private Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long


Private udtRect As RECT
Private udtDrawText As DRAWTEXTPARAMS

' Properties
Private mvarText As String
Private mvarhDc As Long
Private mvarFlags As Long

'local variable(s) to hold property value(s)
Private mvarLeft As Long 'local copy
Private mvarRight As Long 'local copy
Private mvarTop As Long 'local copy
Private mvarBottom As Long 'local copy
Private mvarFont As StdFont

Private Const OUT_DEFAULT_PRECIS = 0
Private Const DEFAULT_QUALITY = 0
Private Const DEFAULT_PITCH = 0
Private Const DEFAULT_CHARSET = 1

Public Property Let Bottom(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Bottom = 5
    mvarBottom = vData
End Property


Public Property Get Bottom() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Bottom
    Bottom = mvarBottom
End Property



Public Property Set Font(vData As Font)
    Set mvarFont = vData
End Property

Public Property Get Font() As StdFont
    Set Font = mvarFont
End Property

Public Property Let Top(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Top = 5
    mvarTop = vData
End Property


Public Property Get Top() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Top
    Top = mvarTop
End Property



Public Property Let Right(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Right = 5
    mvarRight = vData
End Property


Public Property Get Right() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Right
    Right = mvarRight
End Property



Public Property Let Left(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Left = 5
    mvarLeft = vData
End Property


Public Property Get Left() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Left
    Left = mvarLeft
End Property






Public Function DrawText() As Long

    With udtDrawText
        .cbSize = Len(udtDrawText)
        .uiLengthDrawn = Len(mvarText)
    End With
    
    With udtRect
        .Left = mvarLeft
        .Right = mvarRight
        .Top = mvarTop
        .Bottom = mvarBottom
    End With
    
    Dim lf              As LOGFONT
    Dim lngFontToUse    As Long
    Dim lngOldHdc       As Long
    Dim TempByteArray() As Byte
    Dim rc              As RECT
    Dim lngAngle        As Long
    Dim intByteArrayLimit   As Integer
    Dim intCounter      As Integer
    
    On Error Resume Next
    ' If a font was not specified use the default for the Hdc
    lf.lfQuality = 0
    
    
    If Err.Number Then GoTo DrawTextNow
    
    On Error GoTo 0
    
    With lf
        .lfEscapement = 0
        .lfHeight = mvarFont.Size
        .lfItalic = mvarFont.Italic
        .lfStrikeOut = mvarFont.Strikethrough
        .lfUnderline = mvarFont.Underline
        .lfWeight = mvarFont.Weight
        .lfOutPrecision = OUT_DEFAULT_PRECIS
        .lfClipPrecision = OUT_DEFAULT_PRECIS
        .lfQuality = DEFAULT_QUALITY
        .lfPitchAndFamily = DEFAULT_PITCH
        .lfCharSet = DEFAULT_CHARSET
    End With
    
    ' Convert into a Byte Arrary
    TempByteArray = StrConv(mvarFont.Name & Chr$(0), vbFromUnicode)
    
    intByteArrayLimit = UBound(TempByteArray)
    
    For intCounter = 0 To intByteArrayLimit
        lf.lfFaceName(intCounter) = TempByteArray(intCounter)
    Next intCounter
    
    lngFontToUse = CreateFontIndirect(lf)
    
    If lngFontToUse = 0 Then GoTo DrawTextNow
    
    lngOldHdc = SelectObject(mvarhDc, lngFontToUse)
    
    
DrawTextNow:
    On Error GoTo 0
    DrawText = DrawTextEx(mvarhDc, mvarText, Len(mvarText), udtRect, mvarFlags, udtDrawText)
    
    
    Call SelectObject(mvarhDc, lngOldHdc)
    Call DeleteObject(lngFontToUse)
End Function

Public Property Let Flags(lNewFlag As Long)
    mvarFlags = lNewFlag
End Property

Public Property Get Flags() As Long
    Flags = mvarFlags
End Property

Public Property Get hdc() As Long
    hdc = mvarhDc
End Property

Public Property Let hdc(lNewhDc As Long)
    mvarhDc = lNewhDc
End Property

Public Property Let Text(sNewVar As String)
    mvarText = sNewVar
End Property

Public Property Get Text() As String
    Text = mvarText
End Property

